# Reflow

[Documentation](https://reflow.io/docs) | [Readme](https://reflow.io/readme)

Reflow helps product teams create and maintain Automated Browser Tests. It can be run locally or accessed at app.reflow.io. It supports Chromium(Chrome/Edge), Firefox, and WebKit (Safari)

It requires zero programming knowledge to use. It can be enhanced in a product-specific manner by a development team to enable non-technical team members to record/perform arbitrary custom interactions and validations, such as API requests, common login sequences and data seeding.

The primary interface is a Real Time, Multi-User Web UI Dashboard, allowing users to observe executing test sequences as well as create/maintain these test sequences. The secondary interface is a CLI intended for use by a development team.

Reflow wraps the Playwright end-to-end testing framework, and exposes the Playwright interface to snippets.

